package futils.bench;
import java.io.*;
import lyon.audio.*;
import ipl.*;

public class Benchmark {



public static void main(String argv[]) {
	double a[][] = new double[3][3];
	Mat3 m3 = new Mat3(a);
	Timer totalTime = new Timer();
	System.out.println("Bench mark an FFT, IFFT and 10000 "
	+ "3x3 matrix multiplies");
	totalTime.mark();
	FFT.timeFFT();
	for (int i=0; i < 10000; i++) {
		m3.multiply(m3);
	}
	totalTime.record();
	System.out.println("The total time for the benchmarks:");
	totalTime.report();

}

} // end class Benchmark
