package gui;
// SciCalc.java

// compilation unit for the SCIENTIFIC CALCULATOR PROGRAM.



import java.awt.*;

import java.applet.*;

//import java.lang.Math;







/******************************************************************

// Applet representing the Calculator as a Single Unit

******************************************************************/



 class KeyBoard extends Panel{



        Button keyBoardBtn[] = new Button[30];



        //the order in which button to be placed in keyboard

        int buttonOrder[] = { 10, 9, 8, 11, 12, 7, 6, 5, 13, 14,

                          4, 3, 2, 15, 16, 1, 27, 17, 18, 19,

                          20, 21, 22, 23, 24, 25, 26, 0, 28, 29};

        //constructor

        public KeyBoard(){

                int i;



                // set layout as 6 * 5 table

                // 6 rows, 5 cols, width & height of each grid

                setLayout( new GridLayout(6, 5, 5, 5) );



                // create 30 buttons and give them the label



                // create the first button (the mainkey "C" for cancel)

                keyBoardBtn[0] = new Button();

                keyBoardBtn[0].setLabel("C");



                // create 10 buttons for numbers 0-9.

                for(i=1; i<11; i++)

                        keyBoardBtn[i] = new Button( String.valueOf(i-1) );



                //create the remaining buttons for function operators

                keyBoardBtn[11] = new Button("+");

                keyBoardBtn[12] = new Button("-");

                keyBoardBtn[13] = new Button("*");

                keyBoardBtn[14] = new Button("/");

                keyBoardBtn[15] = new Button("1/X");

                keyBoardBtn[16] = new Button("X^2");

                keyBoardBtn[17] = new Button("=");

                keyBoardBtn[18] = new Button("%");

                keyBoardBtn[19] = new Button("Mod");

        

                keyBoardBtn[20] = new Button("Sin");

                keyBoardBtn[21] = new Button("Cos");

                keyBoardBtn[22] = new Button("Tan");

                keyBoardBtn[23] = new Button("Sqrt");

                keyBoardBtn[24] = new Button("Exp");

                keyBoardBtn[25] = new Button("Log");

                keyBoardBtn[26] = new Button("Pow");

                keyBoardBtn[27] = new Button(".");

                keyBoardBtn[28] = new Button("Abs");

                keyBoardBtn[29] = new Button("+/-");





                // Now add 30 buttons to the Grid to display

                for(i=0; i<30; i++)

                        add( keyBoardBtn[ buttonOrder[i] ] );

        }

}







public class SciCalc extends Applet{



        int operation, lastButtonType, countOperation;



        double onScreen, outOfScreen, decimalVal, intPart;



        boolean isDot;



        String  fracPart, dispValue;



        // Display is the one which shows off the result of calculation

        Label display;



        /*****************************

                OVER-RIDED METHOD - 1  

        *****************************/



        public void init(){

                GridBagLayout GBL = new GridBagLayout();

                GridBagConstraints GBC = new GridBagConstraints();



                setLayout( GBL );

                resize( 230, 260 );



                display = new Label( String.valueOf(onScreen), Label.RIGHT );

                GBC.fill = GridBagConstraints.BOTH;

                GBC.weightx = 1.0;

                GBC.weighty = 1.0;

                GBC.gridwidth = GridBagConstraints.REMAINDER;

                GBC.gridheight = 1;

                GBC.ipadx = 5;

                GBC.ipady = 5;

                GBL.setConstraints( display, GBC );

                add( display );



                KeyBoard KB = new KeyBoard();

                GBC.weighty = 4.0;

                GBC.gridheight = 4;

                GBC.ipadx = 1;

                GBC.ipady = 1;

                GBL.setConstraints( KB, GBC );

                add( KB );



                resetCalculator();

        }



        /*****************************

                OVER-RIDED METHOD - 2  

        *****************************/



        public Insets insets(){

                return new Insets(10, 10, 10, 10);

        }



        /*****************************

                OVER-RIDED METHOD - 3  

        *****************************/



		public boolean handleEvent(Event e) {

		  if(e.id == e.WINDOW_DESTROY) {
				hide();
				return true;
			}

			return super.handleEvent(e);

		}

        public boolean action( Event e, Object somebutton ){



                if( e.target instanceof Button ){



                        String temp_string = (String)somebutton;



                        if( temp_string.equals("C") )

                                resetCalculator();

                        else if( temp_string.equals("+") )

                                setOperation(1);

                        else if( temp_string.equals("-") )

                                setOperation(2);

                        else if( temp_string.equals("*") )

                                setOperation(3);

                        else if( temp_string.equals("/") )

                                setOperation(4);

                        else if( temp_string.equals("1/X") ){

                                setOperation(5);

                                doOperation();

                                }

                        else if( temp_string.equals("X^2") ){

                                setOperation(6);

                                doOperation();

                                }

                        else if( temp_string.equals("%") ){

                                setOperation(7);

                                doOperation();

                                }

                        else if( temp_string.equals("Mod") ){

                                setOperation(8);

                                //doOperation();

                                }

                        else if( temp_string.equals("Sin") ){

                                setOperation(9);

                                doOperation();

                                }

                        else if( temp_string.equals("Cos") ){

                                setOperation(10);

                                doOperation();

                                }

                        else if( temp_string.equals("Tan") ){

                                setOperation(11);

                                doOperation();

                                }

                        else if( temp_string.equals("Sqrt") ){

                                setOperation(12);

                                doOperation();

                                }

                        else if( temp_string.equals("Exp") ){

                                setOperation(13);

                                doOperation();

                                }

                        else if( temp_string.equals("Log") ){

                                setOperation(14);

                                doOperation();

                                }

                        else if( temp_string.equals("Pow") ){

                                setOperation(15);

                                //doOperation();

                                }

                        else if( temp_string.equals("+/-") ){

                                setOperation(16);

                                doOperation();

                                }

                        else if( temp_string.equals("Abs") ){

                                setOperation(17);

                                doOperation();

                                }

                        else if( temp_string.equals("=") ){

                                doOperation();

                                countOperation = 0;

                                }

                        else if( temp_string.equals(".") ){

                                isDot = true;

                                if( lastButtonType == 0 )

                                        intPart = onScreen;

                                else intPart = 0;

                                

                                }

                        else{

                                if (!isDot ){

                                   if( lastButtonType == 0 ){

                                        onScreen = onScreen * 10 +

                                            Double.valueOf(temp_string).doubleValue();

                                        dispValue = String.valueOf( onScreen );

        

                                   }else{



                                         onScreen = Double.valueOf(temp_string).doubleValue();

                                        dispValue = String.valueOf( onScreen );

                                   }

                                }else{

                                        fracPart += temp_string;

                                        decimalVal = Double.valueOf( String.valueOf(intPart) 

                                                + "." + fracPart).doubleValue();

                                        onScreen = decimalVal;

                                        dispValue = String.valueOf( intPart )+"."+fracPart;

                                                                                                                

                                }

                                lastButtonType = 0;

                        }



                display.setText( dispValue );

                return true;

                }else return false;

        }

                

        void resetCalculator(){

                onScreen = 0;

                outOfScreen = 0;

                decimalVal = 0;

                

                intPart = 0;

                operation = 0;

                lastButtonType = 0;

                countOperation = 0;

                isDot = false;

                fracPart = new String();

                dispValue = String.valueOf(onScreen);

        }



        void setOperation(int op){

                countOperation++;

                if ( countOperation > 1 )

                        doOperation();

                outOfScreen = onScreen;

                intPart = 0;

                operation = op;

                lastButtonType = op;

                isDot = false;

                fracPart = new String();

        }



        void doOperation(){



                if( lastButtonType != 19 ){



        // do for the first press of "=" button

        // ie for different set of operations

        // eg. 7+5=?*4=?/23=?........



                        double temp;

                        switch( operation ){

                                case 1:

                                        temp = outOfScreen + onScreen;

                                        break;

                                case 2:

                                        temp = outOfScreen - onScreen;

                                        break;

                                case 3:

                                        temp = outOfScreen * onScreen;

                                        break;

                                case 4:

                                        temp = outOfScreen / onScreen;

                                        break;

                                case 5:

                                        temp = 1 / onScreen;

                                        break;

                                case 6:

                                        temp = onScreen * onScreen;

                                        break;

                                case 7:

                                        temp =  onScreen / 100;

                                        break;

                                case 8:

                                        temp =  outOfScreen % onScreen ;

                                        break;

                                case 9:

                                        temp =  Math.sin(onScreen);

                                        break;

                                case 10:

                                        temp =  Math.cos(onScreen);

                                        break;

                                case 11:

                                        temp =  Math.tan(onScreen);

                                        break;

                                case 12:

                                        temp =  Math.sqrt(onScreen);

                                        break;

                                case 13:

                                        temp =  Math.exp(onScreen);

                                        break;

                                case 14:

                                        temp =  Math.log(onScreen);

                                        break;

                                case 15:

                                        temp =  Math.pow(outOfScreen, onScreen);

                                        break;

                                case 16:

                                        temp = onScreen * -1;

                                        break;

                                case 17:

                                        temp = Math.abs(onScreen);

                                        break;

                                case 18:

                                default:

                                        temp = 0;

                                        break;

                        }



        //assign the current number press to outOfScreen

                outOfScreen = onScreen;



        //assign new calculated value to onScreen

                onScreen = temp;



                dispValue = String.valueOf( onScreen );

                }else{



                //do for consecutive press of "=" button.

                //Note here the operation will be the same.

                //eg. 7+5=?=?=?.........



        //Here the outOfScreen remains constant, and the onScreen keeps

        //on changing depending on the number of "=" pressed.



                        switch( operation ){

                                case 1:

                                        onScreen += outOfScreen;

                                        break;

                                case 2:

                                        onScreen -= outOfScreen;

                                        break;

                                case 3:

                                        onScreen *= outOfScreen;

                                        break;

                                case 4:

                                        onScreen /= outOfScreen;

                                        break;

                                case 5:

                                        onScreen = 1 / onScreen;

                                        break;

                                case 6:

                                        onScreen *= onScreen;

                                        break;

                                case 7:

                                        onScreen /= 100;

                                        break;

                                case 8:

                                        onScreen %= outOfScreen;

                                        break;

                                case 9:

                                        onScreen =  Math.sin(onScreen);

                                        break;

                                case 10:

                                        onScreen =  Math.cos(onScreen);

                                        break;

                                case 11:

                                        onScreen =  Math.tan(onScreen);

                                        break;

                                case 12:

                                        onScreen =  Math.sqrt(onScreen);

                                        break;

                                case 13:

                                        onScreen =  Math.exp(onScreen);

                                        break;

                                case 14:

                                        onScreen =  Math.log(onScreen);

                                        break;

                                case 15:

                                        onScreen =  Math.pow(onScreen, outOfScreen);

                                        break;

                                case 16:

                                        onScreen *= -1;

                                        break;

                                case 17:

                                        onScreen = Math.abs(onScreen);

                                        break;

                                case 18:

                                default:

                                        onScreen = 0;

                                        break;

                        

                        }

                dispValue = String.valueOf( onScreen );

                }

                lastButtonType = 19;

        }



}



