package lyon;
import java.applet.Applet;
import java.util.*;
import java.awt.*;
import futils.utils.*;
import futils.Print;


public class point extends Computation { 
	  public double x = 0;
	  public double y = 0;
	  double PI = Math.PI;
	  private double rotation = 0;
	
 	public point add(point t) {
	  return new point(x + t.x, y + t.y);
	}
 	public point scale(point s) {
	  return new point(x * s.x, y * s.y);
	}
 	public point scale(point s, point t) {
	  return new point((x - t.x) * s.x + t.x, (y - t.y)* s.y+t.y);
	}

	public point() {
	}

	public point(double new_x, double new_y) {
	  x = new_x;
	  y = new_y;
 	}
 	public point(point np) {
	  x = np.x;
	  y = np.y;
	}
	
	public void setPoint(double _x, double _y) {
		x = _x;
		y = _y;
	}
 	public double magnitude() {
 		return Math.sqrt(x*x+y*y);
 	}
 	
 	public double distance(point np) {
 		double delta_x = np.x - x;
 		double delta_y = np.y - y;
 		return Math.sqrt(delta_x * delta_x + delta_y * delta_y);
 	}
 public void print() {
 	System.out.print( this.getClass().getName() + " = ");
 	Print.print("\t"+ x + "\t" + y);
 	 }
 	 
 public void println() {
 	System.out.print( this.getClass().getName() + " = ");
 	Print.ln("\t"+ x + "\t" + y);
 	 }
 	 
 public point intersect(point p2, point p3, point p4) {
 	point pi;
	double a1,b1,c1,a2,b2,c2,foo;

	a1 = p2.y - y;
	b1 = x - p2.x;
	c1 = p2.x * y - x * p2.y;
	a2 = p4.y - p3.y;
	b2 = p3.x - p4.x;
	c2 = p4.x * p3.y - p3.x * p4.y;
	foo = a1 * b2 - a2 * b1;
	pi = new point((b1 * c2 - b2 * c1)/ foo,
					(a2 * c1- a1 * c2)/ foo);
 return pi;
 }
 	 
 public point intersect(point p2,point p3, double theta)
    {
    	double tx, ct;
    	ct = Math.tan(PI/2-theta);
    	print();
    	p2.print();
    	p3.print();
    	point pi = new point(0,0);
    	// intersect lines p1-p2 with p3-p4
    	tx=(ct*(x - p3.x) + p3.y - y)/(p2.y-y-ct*(p2.x-x));
    	System.out.println("tx ="+tx);
    	System.out.println("Theta ="+ theta *180/PI);
    	pi.x = x + (p2.x-x)*tx;
    	pi.y = y + (p2.y-y)*tx;
    	return pi;
    }
 
public point rotate(point pc, double theta) {
     	// rotate point p about pc an amount of theta radians
     	// return a new point
     	double c_theta = Math.cos(theta);
     	double s_theta = Math.sin(theta);
     	double dx = x - pc.x;
     	double dy = y - pc.y;
     	// you need tempx and tempy to
     	// control the order of computation!
     	double tx = pc.x + dx * c_theta - dy * s_theta;
     	double ty = pc.y + dy * c_theta + dx * s_theta;
     	return ( new point(tx, ty));
}

 

 public void test()
    {
		double theta;
    	
    	point p2 = new point(3,2);
    	point p3 = new point(0,3);
    	x=0;
    	y=0;
		theta = 45 * PI/180;
    	
    	point pi= new point(0,0);
    	
    	pi = intersect(p2,p3,theta);
    	System.out.print("ray test returns a point ");
    	pi.print();
    }
    
}
