package threads; 
import java.util.*;
import java.awt.*;
import java.applet.Applet;


// DigitalThreads must extend applet to getFontMetrics.
public class DigitalThreads  extends Applet implements Runnable {
	public Thread runner;
	public Graphics g;
	public Frame f;
	
	public void start() {
		if (runner == null) {

			runner = new Thread(this);
			runner.start();
		}
	}
	
	public void stop() {
	     if (runner != null) {
	     	runner.stop();
			runner = null;
			}
	}
	
	
	synchronized private void draw() {
		Dimension dim = f.getSize();
		int height = dim.height - 60;
		int width = dim.width;
		Date theDate = new Date();
	 	String date_string = theDate.toString();
		int xloc = 10;
	  	int yloc = dim.height - 60;
		   	

     		// g.setFont(f);
		// get the string width in pixels this always returns 0.
		int string_width = getFontMetrics(
		   		g.getFont()).stringWidth(date_string);
		int string_height = getFontMetrics(
		   		g.getFont()).getHeight();
		 		
		g.clearRect(xloc,yloc,string_width,string_height);
      	g.drawString(date_string, xloc,height+xloc);
	}


	public void run() {
		while (true) {
			draw();
			try {Thread.sleep(1000);}
			catch (InterruptedException e) {}
		}
	}
}








